<?php
/**
 * GluingProperty
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Catalog Cache
 *
 * Ensi Catalog Cache
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CatalogCacheClient\Dto;

use \ArrayAccess;
use \Ensi\CatalogCacheClient\ObjectSerializer;

/**
 * GluingProperty Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class GluingProperty implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'GluingProperty';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'prop_type' => 'string',
        'prop_name' => 'string',
        'prop_code' => 'string',
        'value_value' => 'string',
        'value_name' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'prop_type' => null,
        'prop_name' => null,
        'prop_code' => null,
        'value_value' => null,
        'value_name' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'prop_type' => false,
        'prop_name' => false,
        'prop_code' => false,
        'value_value' => false,
        'value_name' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'prop_type' => 'prop_type',
        'prop_name' => 'prop_name',
        'prop_code' => 'prop_code',
        'value_value' => 'value_value',
        'value_name' => 'value_name'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'prop_type' => 'setPropType',
        'prop_name' => 'setPropName',
        'prop_code' => 'setPropCode',
        'value_value' => 'setValueValue',
        'value_name' => 'setValueName'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'prop_type' => 'getPropType',
        'prop_name' => 'getPropName',
        'prop_code' => 'getPropCode',
        'value_value' => 'getValueValue',
        'value_name' => 'getValueName'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('prop_type', $data, null);
        $this->setIfExists('prop_name', $data, null);
        $this->setIfExists('prop_code', $data, null);
        $this->setIfExists('value_value', $data, null);
        $this->setIfExists('value_name', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['prop_type'] === null) {
            $invalidProperties[] = "'prop_type' can't be null";
        }
        if ($this->container['prop_name'] === null) {
            $invalidProperties[] = "'prop_name' can't be null";
        }
        if ($this->container['prop_code'] === null) {
            $invalidProperties[] = "'prop_code' can't be null";
        }
        if ($this->container['value_value'] === null) {
            $invalidProperties[] = "'value_value' can't be null";
        }
        if ($this->container['value_name'] === null) {
            $invalidProperties[] = "'value_name' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets prop_type
     *
     * @return string
     */
    public function getPropType()
    {
        return $this->container['prop_type'];
    }

    /**
     * Sets prop_type
     *
     * @param string $prop_type Тип атрибута
     *
     * @return $this
     */
    public function setPropType($prop_type)
    {


        /*if (is_null($prop_type)) {
            throw new \InvalidArgumentException('non-nullable prop_type cannot be null');
        }*/
        $this->container['prop_type'] = $prop_type;

        return $this;
    }

    /**
     * Gets prop_name
     *
     * @return string
     */
    public function getPropName()
    {
        return $this->container['prop_name'];
    }

    /**
     * Sets prop_name
     *
     * @param string $prop_name Название атрибута на витрине
     *
     * @return $this
     */
    public function setPropName($prop_name)
    {


        /*if (is_null($prop_name)) {
            throw new \InvalidArgumentException('non-nullable prop_name cannot be null');
        }*/
        $this->container['prop_name'] = $prop_name;

        return $this;
    }

    /**
     * Gets prop_code
     *
     * @return string
     */
    public function getPropCode()
    {
        return $this->container['prop_code'];
    }

    /**
     * Sets prop_code
     *
     * @param string $prop_code Код атрибута
     *
     * @return $this
     */
    public function setPropCode($prop_code)
    {


        /*if (is_null($prop_code)) {
            throw new \InvalidArgumentException('non-nullable prop_code cannot be null');
        }*/
        $this->container['prop_code'] = $prop_code;

        return $this;
    }

    /**
     * Gets value_value
     *
     * @return string
     */
    public function getValueValue()
    {
        return $this->container['value_value'];
    }

    /**
     * Sets value_value
     *
     * @param string $value_value Значение атрибута
     *
     * @return $this
     */
    public function setValueValue($value_value)
    {


        /*if (is_null($value_value)) {
            throw new \InvalidArgumentException('non-nullable value_value cannot be null');
        }*/
        $this->container['value_value'] = $value_value;

        return $this;
    }

    /**
     * Gets value_name
     *
     * @return string|null
     */
    public function getValueName()
    {
        return $this->container['value_name'];
    }

    /**
     * Sets value_name
     *
     * @param string|null $value_name Название значения атрибута
     *
     * @return $this
     */
    public function setValueName($value_name)
    {

        if (is_null($value_name)) {
            array_push($this->openAPINullablesSetToNull, 'value_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('value_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['value_name'] = $value_name;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


